## sff 1.1

=== Makefile ===
# sff - simple file finder

# paths
PREFIX = /usr/local
MANPREFIX = ${PREFIX}/share/man

EXTFNNAME = sff-extfunc
EXTFNPREFIX = ${PREFIX}/lib/sff

# includes and libs
OS = $(shell uname -s)
INCS = $(shell [ '$(OS)' = "Linux" ] && echo "-I/usr/include/ncursesw"; \
		[ '$(OS)' = "Darwin" ] && echo "-I/usr/local/opt/ncurses/include")
LIBS = $(shell [ '$(OS)' = "Darwin" ] && echo "-L/usr/local/opt/ncurses/lib") -lncursesw

# flags
CPPFLAGS =
CFLAGS   = -std=c11 -O2 -Wall -Wextra -fstack-protector-strong ${INCS} ${CPPFLAGS}
LDFLAGS  = ${LIBS} -s

# compiler and linker
CC = cc

# ===========================================================================

SRC = sff.c
OBJ = ${SRC:.c=.o}

all: options sff

options:
	@echo sff build options:
	@echo "CFLAGS   = ${CFLAGS}"
	@echo "LDFLAGS  = ${LDFLAGS}"
	@echo "CC       = ${CC}"

.c.o:
	${CC} -c ${CFLAGS} $<

${OBJ}: config.h

config.h:
	cp config.def.h $@

sff: ${OBJ}
	${CC} -o $@ ${OBJ} ${LDFLAGS}

clean:
	rm -f sff ${OBJ} sff.1.gz sff*.tar.gz

dist: clean
	mkdir -p sff
	cp -R CHANGELOG.md LICENSE Makefile README.md config.h plugins sff.1 ${SRC} ${EXTFNNAME} sff/
	tar -cf sff.tar sff
	gzip sff.tar
	rm -rf sff

install: all
	mkdir -p ${DESTDIR}${PREFIX}/bin
	install -m 755 sff ${DESTDIR}${PREFIX}/bin/
	mkdir -p ${DESTDIR}${EXTFNPREFIX}
	cp -fR ${EXTFNNAME} plugins ${DESTDIR}${EXTFNPREFIX}/
	chmod -R 755 ${DESTDIR}${EXTFNPREFIX}
	mkdir -p ${DESTDIR}${MANPREFIX}/man1
	gzip -fk sff.1
	install -m 644 sff.1.gz ${DESTDIR}${MANPREFIX}/man1/

uninstall:
	rm -rf ${DESTDIR}${PREFIX}/bin/sff \
		${DESTDIR}${EXTFNPREFIX} \
		${DESTDIR}${MANPREFIX}/man1/sff.1.gz

.PHONY: all options clean dist install uninstall

=== debian/changelog ===
sff (1.1-1) unstable; urgency=medium

  * Initial release (Closes: #1108135)

 -- Shi Yanling <sylphenix@outlook.com>  Tue, 24 Jun 2025 10:30:00 +0800

=== debian/control ===
Source: sff
Section: utils
Priority: optional
Maintainer: Shi Yanling <sylphenix@outlook.com>
Rules-Requires-Root: no
Build-Depends: debhelper-compat (= 13), libncurses-dev
Standards-Version: 4.7.2
Homepage: https://codeberg.org/sylphenix/sff
Vcs-Browser: https://salsa.debian.org/sylphenix/sff
Vcs-Git: https://salsa.debian.org/sylphenix/sff.git

Package: sff
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: xdg-utils, fzf, 7zip, chafa, poppler-utils, ffmpegthumbnailer
Description: Simple, fast, friendly terminal file manager
 sff is a simple, fast, and feature-rich terminal file manager inspired
 by nnn and guided by the suckless philosophy. It aims to provide a
 reliable, efficient, and user-friendly file management experience with
 high extensibility.
 .
 Features:
  - Extensible with shell scripts
  - Customizable detail columns
  - Type-to-navigate
  - Advanced search via 'find'
  - Fast file search via 'fzf'
  - Convenient temporary sudo mode
  - Undo/Redo for the last file operation
  - Batch file and directory creation
  - Batch rename
  - Multi-tab support, cross-directory selection
  - Extract and create archives
  - Fast startup and low memory footprint

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND := -std=c11
export DEB_LDFLAGS_MAINT_APPEND := -lncursesw
export DEB_CPPFLAGS_MAINT_APPEND := -DEXTFNPREFIX=\\\"/usr/libexec/sff\\\"

%:
	dh $@

override_dh_auto_configure:

override_dh_auto_build:
	$(MAKE) CFLAGS="$(shell dpkg-buildflags --get CFLAGS) $(shell dpkg-buildflags --get CPPFLAGS)" \
		LDFLAGS="$(shell dpkg-buildflags --get LDFLAGS)"

override_dh_auto_install:
	$(MAKE) install DESTDIR=$(CURDIR)/debian/sff PREFIX=/usr

override_dh_auto_clean:
	$(MAKE) clean

override_dh_install:
	dh_install
	mkdir -p debian/sff/usr/share/doc/sff
	install -m 644 CHANGELOG.md debian/sff/usr/share/doc/sff/changelog
	install -m 644 README.md debian/sff/usr/share/doc/sff/
	gzip -9n debian/sff/usr/share/doc/sff/changelog debian/sff/usr/share/doc/sff/README.md

override_dh_compress:
	dh_compress -X.1.gz

=== debian/watch ===
version=4
https://codeberg.org/sylphenix/sff/releases .*/v?(\d\S+)\.tar\.gz

## sff 1.2

=== Makefile ===
# sff - simple file finder

# paths
PREFIX = /usr/local
MANPREFIX = ${PREFIX}/share/man

EXTFNNAME = sff-extfunc
EXTFNPREFIX = ${PREFIX}/lib/sff

# includes and libs
OS = $(shell uname -s)
INCS = $(shell [ '${OS}' = 'Linux' ] && echo "-I/usr/include/ncursesw"; \
		[ '${OS}' = 'Darwin' ] && echo "-I/usr/local/opt/ncurses/include")
LIBS = $(shell [ '${OS}' = 'Darwin' ] && echo "-L/usr/local/opt/ncurses/lib") -lncursesw

# flags
CPPFLAGS =
CFLAGS   = -std=c11 -O2 -Wall -Wextra -fstack-protector-strong ${INCS} ${CPPFLAGS}
LDFLAGS  = ${LIBS}

# compiler and linker
CC = cc

# ===========================================================================

SRC = sff.c
OBJ = ${SRC:.c=.o}

all: options sff

options:
	@echo sff build options:
	@echo "CFLAGS   = ${CFLAGS}"
	@echo "LDFLAGS  = ${LDFLAGS}"
	@echo "CC       = ${CC}"

config.h:
	cp config.def.h $@

${OBJ}: config.h

%.o: %.c
	${CC} -c ${CFLAGS} -o $@ $<

sff: ${OBJ}
	${CC} -o $@ ${OBJ} ${LDFLAGS}

clean:
	rm -f sff ${OBJ} sff*.tar.gz

dist: clean
	mkdir -p sff
	cp -Rf CHANGELOG.md README.md LICENSE Makefile config.h plugins sff.1 ${SRC} ${EXTFNNAME} sff/
	tar -caf sff.tar.gz sff
	rm -rf sff

install: all
	mkdir -p "${DESTDIR}${PREFIX}/bin"
	install -m 755 sff "${DESTDIR}${PREFIX}/bin/"
	mkdir -p "${DESTDIR}${EXTFNPREFIX}"
	cp -Rf ${EXTFNNAME} plugins "${DESTDIR}${EXTFNPREFIX}/"
	chmod -R 755 "${DESTDIR}${EXTFNPREFIX}"
	mkdir -p "${DESTDIR}${MANPREFIX}/man1"
	install -m 644 sff.1 "${DESTDIR}${MANPREFIX}/man1/"
	gzip -nf "${DESTDIR}${MANPREFIX}/man1/sff.1"

uninstall:
	rm -rf "${DESTDIR}${PREFIX}/bin/sff" \
		"${DESTDIR}${EXTFNPREFIX}" \
		"${DESTDIR}${MANPREFIX}/man1/sff.1.gz"

.PHONY: all options clean dist install uninstall

=== debian/changelog ===
sff (1.2-1) unstable; urgency=medium

  * Fix FTCBFS: Let dh_auto_build pass cross tools to make (Closes: #1119128)
  * Properly handle paths containing invalid encoding characters
  * Changed scripts install path from libexec/sff/ to lib/sff/
  * Clean up preview FIFO file on exit
  * Quick-find input remains after a failed navigation
  * Symlink target paths no longer folded in status bar
  * Now shows a warning when chdir fails during tab switching

 -- Shi Yanling <sylphenix@outlook.com>  Wed, 17 Dec 2025 11:02:00 +0800

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- CFLAGS="$(shell dpkg-buildflags --get CFLAGS) -std=c11" \
		LDFLAGS="$(shell dpkg-buildflags --get LDFLAGS) -lncursesw"

override_dh_auto_install:
	$(MAKE) install DESTDIR="$(CURDIR)/debian/sff" PREFIX=/usr
